# install_tk.rb  for tenji2kana ver 1.2  2008.10.05
# Copyright (C) T. Yoshiizumi, 2008 All rights reserved.
require 'Win32API'
require 'win32ole'
require 'fileutils.rb'

# ^ꂽtH_쐬
def check_and_make_dir(dir_name)
  count = 1
  while true
    if test(?d, dir_name)
      break
    end
    unless test(?e, dir_name)
      Dir.mkdir(dir_name)
      break
    end
    count += 1
    dir_name = sprintf("%s%d", dir_name, count)
  end
  return dir_name
end

# t@C̍ċNIRs[
def file_repeat_copy(src_list, dest_dir)
  dest_dir = dest_dir.gsub(/\\/, "/")
  unless test(?d, dest_dir)
    return
  end
  for fname in src_list
    fname = fname.gsub(/\\/, "/")
    next  unless test(?e, fname)
    if test(?d, fname)
      base_name = File.basename(fname)
      new_dest_dir = dest_dir.sub(/\/$/, "")  + "/" + base_name
      Dir.mkdir(new_dest_dir)  unless test(?e, new_dest_dir)
      next  unless test(?d, new_dest_dir)
      wcard = fname.sub(/\/$/, "") + "/*"
      new_src_list = Dir.glob(wcard)
      file_repeat_copy(new_src_list, new_dest_dir)
    else  # fnamefBNgł͂Ȃ
      FileUtils.copy(fname, dest_dir, {:preserve => true})
    end
  end
end

# ݒ
prog_name = 'tenji2kana.exe'
message_box = Win32API.new('user32', 'MessageBoxA', 'LPPI', 'I')
wsh = WIN32OLE.new("WScript.Shell")
unless wsh
  w = "WSHĂȂ߃CXg[ł܂D}jAQƂȂƂŃCXg[ĉD"
  message_box.call(0, w, '_Jiւ̕ϊ@CXg[', 0)
  exit
end

# KvȃtH_̎擾
src_dir = File.dirname(ExerbRuntime::filepath())
src_dir.gsub!(/\//, "\\")
src_file = sprintf("%s\\%s", src_dir, prog_name)
unless test(?e, src_file)
  w = sprintf("AvP[Vt@C %s݂܂DCXg[߂܂D", src_file)
  message_box.call(0, w, '_Jiւ̕ϊ@CXg[', 0)
  exit
end
sendto_dir = wsh.SpecialFolders("SendTo")
if sendto_dir =~ /\\$/
  sendto_dir = sendto_dir.sub(/\\$/, "")
end

# CXg[̃tH_߂
w = "C:\\usr"
w = check_and_make_dir(w)
dest_dir = sprintf("%s\\tenji2kana", w)
unless test(?e, dest_dir)
  Dir.mkdir(dest_dir)
end
unless test(?d, dest_dir)
  w = sprintf("%sƂtH_݂܂łDCXg[߂܂D", dest_dir)
  message_box.call(0, w, 'z[y[W̋L擾@CXg[', 0)
  exit
end

# t@C̃Rs[
src_list = [src_dir + "\\tenji2kana.exe", src_dir + "\\tenji2kana.txt",
            src_dir + "\\prebrl.exe", src_dir + "\\script"]
unless src_dir.downcase == dest_dir.downcase
  file_repeat_copy(src_list, dest_dir)
end

# ob`R}h̍쐬
bf = sprintf("%s\\tenji2kana_org.bat", dest_dir)
outfile = open(bf, "w")
outfile.printf("@echo off\n\"%s\\tenji2kana.exe\" \"-path=%s\" %%*\nexit\n", dest_dir, dest_dir)
outfile.close
bf = sprintf("%s\\tenji2kana_simple.bat", dest_dir)
outfile = open(bf, "w")
outfile.printf("@echo off\n\"%s\\tenji2kana.exe\" \"-path=%s\" -simple %%*\nexit\n", dest_dir, dest_dir)
outfile.close

# V[gJbg̍쐬
exe_file = sprintf("%s\\tenji2kana_org.bat", dest_dir)
link_file1 = sprintf("%s\\T _Jiւ̕ϊEǂݏグp.lnk", sendto_dir)
shortcut = wsh.CreateShortCut(link_file1)
shortcut.targetPath = exe_file
shortcut.save

exe_file = sprintf("%s\\tenji2kana_simple.bat", dest_dir)
link_file2 = sprintf("%s\\T _Jiւ̕ϊEʏ^.lnk", sendto_dir)
shortcut2 = wsh.CreateShortCut(link_file2)
shortcut2.targetPath = exe_file
shortcut2.save

# uninstall̂߂̃ob`o
tmp_def = dest_dir + "\\uninstall_TK.def"
outfile = open(tmp_def, "w")
outfile.printf("@ECHO OFF\n")
outfile.printf("DEL /F /Q \"%s\"\n", link_file1)
outfile.printf("DEL /F /Q \"%s\"\n", link_file2)
outfile.printf("CD /D \"%s\"\n", dest_dir)
outfile.printf("CD ..\n")
outfile.printf("RMDIR /S /Q \"%s\"\n", dest_dir)
outfile.close
    ##
tmp_bat = dest_dir + "\\uninstall_TK.bat"
outfile = open(tmp_bat, "w")
outfile.printf("@ECHO OFF\n")
outfile.printf("CD /D \"%s\"\n", dest_dir)
outfile.printf("CD ..\n")
outfile.printf("TYPE \"%s\" > uninstall_x.bat\n", tmp_def)
outfile.printf("uninstall_x.bat\n")
outfile.close

# I
w = sprintf("Kvȃt@C%sɃRs[Cuvj[ɓ̍ڂo^܂DǂݏグpipȂ̃^Cvjƒʏ^̓܂DvOꎮ鎞uninstall_tk.batsĉD", dest_dir)
message_box.call(0, w, '_Jiւ̕ϊ@CXg[I', 0)
exit
